"use strict";
const libs_resources = require("../../../libs/resources.js");
const api_common = require("../../../api/common.js");
const common_vendor = require("../../../common/vendor.js");
const _sfc_main = {
  props: {
    interfaceId: {
      type: String,
      default: ""
    },
    clearable: {
      type: Boolean,
      default: true
    },
    relationField: {
      type: String,
      default: "fullName"
    },
    total: {
      type: [String, Number],
      default: 50
    },
    formData: {
      type: Object
    },
    templateJson: {
      type: Array,
      default: () => []
    },
    rowIndex: {
      default: null
    }
  },
  data() {
    return {
      istQuery: {
        keyword: "",
        pageSize: 1e3
      },
      icon: libs_resources.resources.message.nodata,
      showPopup: false,
      value: "",
      showList: [],
      timer: ""
    };
  },
  methods: {
    init(val) {
      this.showPopup = true;
      this.value = val;
      this.getDataInterfaceList();
    },
    getDataInterfaceList() {
      this.showList = [];
      const paramList = this.getParamList();
      let query = {
        interfaceId: this.interfaceId,
        relationField: this.relationField,
        pageSize: 1e4,
        paramList
      };
      api_common.getPopSelect(this.interfaceId, query).then((res) => {
        let list = JSON.parse(JSON.stringify(res.data.list)) || [];
        if (list.length)
          list = this.unique(list, this.relationField);
        this.showList = list.splice(0, this.total);
      });
    },
    unique(arr, attrName) {
      const res = /* @__PURE__ */ new Map();
      return arr.filter((o) => !res.has(o[attrName]) && res.set(o[attrName], 1));
    },
    getParamList() {
      let templateJson = this.templateJson;
      for (let i = 0; i < templateJson.length; i++) {
        if (templateJson[i].relationField && this.formData && templateJson[i].sourceType == 1) {
          if (templateJson[i].relationField.includes("-")) {
            let tableVModel = templateJson[i].relationField.split("-")[0];
            let childVModel = templateJson[i].relationField.split("-")[1];
            templateJson[i].defaultValue = this.formData[tableVModel] && this.formData[tableVModel][this.rowIndex] && this.formData[tableVModel][this.rowIndex][childVModel] || "";
          } else {
            templateJson[i].defaultValue = this.formData[templateJson[i].relationField] || "";
          }
        }
        if (templateJson[i].relationField == "@keyword")
          templateJson[i].defaultValue = this.value;
      }
      return templateJson;
    },
    onInput(e) {
      this.value = e;
      this.$emit("confirm", this.value);
      this.timer && clearTimeout(this.timer);
      this.timer = setTimeout(() => {
        this.list = [];
        this.getDataInterfaceList();
      }, 300);
    },
    close() {
      this.showPopup = false;
    },
    selectThisItem(item) {
      this.value = item[this.relationField];
      this.$emit("confirm", this.value);
      this.close();
    }
  }
};
if (!Array) {
  const _easycom_u_icon2 = common_vendor.resolveComponent("u-icon");
  const _easycom_u_input2 = common_vendor.resolveComponent("u-input");
  const _easycom_u_popup2 = common_vendor.resolveComponent("u-popup");
  (_easycom_u_icon2 + _easycom_u_input2 + _easycom_u_popup2)();
}
const _easycom_u_icon = () => "../../../uni_modules/vk-uview-ui/components/u-icon/u-icon.js";
const _easycom_u_input = () => "../../../uni_modules/vk-uview-ui/components/u-input/u-input.js";
const _easycom_u_popup = () => "../../../uni_modules/vk-uview-ui/components/u-popup/u-popup.js";
if (!Math) {
  (_easycom_u_icon + _easycom_u_input + _easycom_u_popup)();
}
function _sfc_render(_ctx, _cache, $props, $setup, $data, $options) {
  return common_vendor.e({
    a: common_vendor.o(($event) => $data.showPopup = false),
    b: common_vendor.p({
      name: "close"
    }),
    c: common_vendor.o($options.onInput),
    d: common_vendor.o(($event) => $data.value = $event),
    e: common_vendor.p({
      type: "text",
      placeholder: "请输入",
      clearable: $props.clearable,
      modelValue: $data.value
    }),
    f: $data.showList.length > 0
  }, $data.showList.length > 0 ? {
    g: common_vendor.f($data.showList, (item, index, i0) => {
      return {
        a: common_vendor.t(item[$props.relationField]),
        b: index,
        c: common_vendor.o(($event) => $options.selectThisItem(item), index)
      };
    })
  } : {}, {
    h: $data.showList.length < 1
  }, $data.showList.length < 1 ? {
    i: $data.icon
  } : {}, {
    j: common_vendor.o($options.close),
    k: common_vendor.o(($event) => $data.showPopup = $event),
    l: common_vendor.p({
      width: "100%",
      height: "100vh",
      mode: "right",
      mask: false,
      modelValue: $data.showPopup
    })
  });
}
const Component = /* @__PURE__ */ common_vendor._export_sfc(_sfc_main, [["render", _sfc_render]]);
wx.createComponent(Component);
