"use strict";
const common_vendor = require("../../../common/vendor.js");
const SearchForm = () => "./SearchForm.js";
const _sfc_main = {
  name: "jnpf-auto-complete",
  components: {
    SearchForm
  },
  props: {
    modelValue: {
      default: ""
    },
    formData: {
      type: Object
    },
    options: {
      type: Array,
      default: () => []
    },
    placeholder: {
      type: String,
      default: "请输入"
    },
    clearable: {
      type: Boolean,
      default: false
    },
    disabled: {
      type: Boolean,
      default: false
    },
    templateJson: {
      type: Array,
      default: () => []
    },
    interfaceId: {
      type: String,
      default: ""
    },
    relationField: {
      type: String,
      default: "fullName"
    },
    total: {
      type: Number,
      default: 50
    },
    rowIndex: {
      default: null
    }
  },
  data() {
    return {
      innerValue: ""
    };
  },
  watch: {
    modelValue: {
      handler(val) {
        this.innerValue = val || "";
      },
      immediate: true
    }
  },
  methods: {
    showSearch() {
      if (this.disabled)
        return;
      this.$nextTick(() => {
        this.$refs.searchForm.init(this.innerValue);
      });
    },
    confirm(e) {
      this.innerValue = e;
      this.$emit("update:modelValue", e);
      this.$emit("change", e);
    }
  }
};
if (!Array) {
  const _easycom_u_input2 = common_vendor.resolveComponent("u-input");
  const _component_SearchForm = common_vendor.resolveComponent("SearchForm");
  (_easycom_u_input2 + _component_SearchForm)();
}
const _easycom_u_input = () => "../../../uni_modules/vk-uview-ui/components/u-input/u-input.js";
if (!Math) {
  _easycom_u_input();
}
function _sfc_render(_ctx, _cache, $props, $setup, $data, $options) {
  return {
    a: common_vendor.o($options.showSearch),
    b: common_vendor.o(($event) => $data.innerValue = $event),
    c: common_vendor.p({
      ["input-align"]: "right",
      type: "select",
      placeholder: $props.placeholder,
      modelValue: $data.innerValue
    }),
    d: common_vendor.sr("searchForm", "7a33e6d4-1"),
    e: common_vendor.o($options.confirm),
    f: common_vendor.p({
      interfaceId: $props.interfaceId,
      relationField: $props.relationField,
      templateJson: $props.templateJson,
      total: $props.total || 50,
      formData: $props.formData,
      clearable: $props.clearable,
      rowIndex: $props.rowIndex
    })
  };
}
const Component = /* @__PURE__ */ common_vendor._export_sfc(_sfc_main, [["render", _sfc_render]]);
wx.createComponent(Component);
